"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (function (width, height, backgroundColor, mixinStyles) {
    return {
        modalContainer: __assign({ backgroundColor: backgroundColor, justifyContent: 'center', alignItems: 'center', overflow: 'hidden' }, mixinStyles.modalContainer),
        watchOrigin: __assign({ position: 'absolute', width: width, bottom: 20, justifyContent: 'center', alignItems: 'center' }, mixinStyles.watchOrigin),
        watchOriginTouchable: __assign({ paddingLeft: 10, paddingRight: 10, paddingTop: 5, paddingBottom: 5, borderRadius: 30, borderColor: 'white', borderWidth: 0.5, backgroundColor: 'rgba(0, 0, 0, 0.1)' }, mixinStyles.watchOriginTouchable),
        watchOriginText: __assign({ color: 'white', backgroundColor: 'transparent' }, mixinStyles.watchOriginText),
        imageStyle: __assign({}, mixinStyles.imageStyle),
        container: __assign({ backgroundColor: backgroundColor }, mixinStyles.container),
        moveBox: __assign({ flexDirection: 'row', alignItems: 'center' }, mixinStyles.moveBox),
        menuContainer: __assign({ position: 'absolute', width: width, height: height, left: 0, bottom: 0, zIndex: 12 }, mixinStyles.menuContainer),
        menuShadow: __assign({ position: 'absolute', width: width,
            height: height, backgroundColor: 'black', left: 0, bottom: 0, opacity: 0.2, zIndex: 10 }, mixinStyles.menuShadow),
        menuContent: __assign({ position: 'absolute', width: width, left: 0, bottom: 0, zIndex: 11 }, mixinStyles.menuContent),
        operateContainer: __assign({ justifyContent: 'center', alignItems: 'center', backgroundColor: 'white', height: 40, borderBottomColor: '#ccc', borderBottomWidth: 1 }, mixinStyles.operateContainer),
        operateText: __assign({ color: '#333' }, mixinStyles.operateText),
        loadingTouchable: __assign({ width: width, height: height }, mixinStyles.loadingTouchable),
        loadingContainer: __assign({ justifyContent: 'center', alignItems: 'center' }, mixinStyles.loadingContainer),
        arrowLeftContainer: __assign({ position: 'absolute', top: 0, bottom: 0, left: 0, justifyContent: 'center', zIndex: 13 }, mixinStyles.arrowLeftContainer),
        arrowRightContainer: __assign({ position: 'absolute', top: 0, bottom: 0, right: 0, justifyContent: 'center', zIndex: 13 }, mixinStyles.arrowRightContainer),
    };
});
exports.simpleStyle = {
    count: {
        position: 'absolute',
        left: 0,
        right: 0,
        top: 38,
        zIndex: -1,
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor: 'transparent'
    },
    countText: {
        color: 'white',
        fontSize: 16,
        backgroundColor: 'transparent',
        textShadowColor: 'rgba(0, 0, 0, 0.3)',
        textShadowOffset: {
            width: 0,
            height: 0.5
        },
        textShadowRadius: 0
    }
};
//# sourceMappingURL=image-viewer.style.js.map